// FHanoy.h: interface for the FHanoy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FHANOY_H__1FA9BA81_B54B_11D6_A493_E8B361F14361__INCLUDED_)
#define AFX_FHANOY_H__1FA9BA81_B54B_11D6_A493_E8B361F14361__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "..\Tasks\FRcrsn.h"

class TInfoAppl;
class FHanoy : public FRcrsn  
{
public:
	void Move();//	    k   nA   nB
	int nK;		//	 ;   (k)
	int nA;		//	 ( : =1, b=2, c=3)
	int nB;		//	 ( )
	FHanoy(int k, int a, int b, TInfoAppl *pInf, int r);
	virtual ~FHanoy();
private:
	FHanoy *pHanoy;

	int x1();
	void y1(); 
	void y2();
	void y3();
// for algorithm A.Legalov
public:
	unsigned disks;	//	 
private:
	unsigned disk_number; //  
	unsigned steps;	//  
	unsigned i;		//  
	unsigned shifts;//    
	unsigned delta;	//  
	int x2();		//
	void y4();		//	 
	void y5();		//	  
	void y6();		//	   
	void y7();		//	     
	void y8();		//	  . 
	void y9();		//	. 
	void y10();		//	. 
	void y11();		//	. 

protected:
	void CallHanoy(int k, int a, int b, TInfoAppl *pInf, int r)	{
		if (pHanoy) delete  pHanoy;
		pHanoy = new FHanoy(k, a, b, pInf, r);
		pHanoy->FCall(this); 
	}
};

#endif // !defined(AFX_FHANOY_H__1FA9BA81_B54B_11D6_A493_E8B361F14361__INCLUDED_)
