// FTskHanoy.cpp: implementation of the FTskHanoy class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"
#include "FTskHanoy.h"
#include "FHanoy.h"
#include "..\Views\FViewHanoy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FTskHanoy::FTskHanoy(TInfoAppl *pInf, TNetFsa *pNt)
	:FTask(pInf, pNt)
{
	pViewStates=NULL;
}

FTskHanoy::~FTskHanoy()
{
	if (pAppl) delete pAppl;
	if (pViewStates) delete pViewStates;
}

void FTskHanoy::y1()
{
	pAppl = NULL;
	pViewStates=NULL;
	int nHanoy = ((CRcrsnView*)pInfo->pOutWnd)->m_nHanoy;
	pAppl = new FHanoy(nHanoy,1,2, pInfo, 1);
	((CRcrsnView*)pInfo->pOutWnd)->InitHanoy(nHanoy);

	if (((CRcrsnView*)pInfo->pOutWnd)->m_bViewStateHanoy) {
		pViewStates = new FViewHanoy(pNet, pInfo);
		pViewStates->SetPtrFsaAppl((LFsaAppl**)&pAppl);
		pNet->go_task();
	}

	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeHanoy(0);	

	FTask::y1();

}

void FTskHanoy::y2()
{
	FTask::y2();
	
	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeHanoy(nSeconds);	
	if (pAppl) delete pAppl;
	if (pViewStates) delete pViewStates;
	pAppl = NULL;
	pViewStates=NULL;
}
