// FAkerm.h: interface for the FAkerm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAKERM_H__8776F961_B0EC_11D6_B4EC_00C0DF0F1E3A__INCLUDED_)
#define AFX_FAKERM_H__8776F961_B0EC_11D6_B4EC_00C0DF0F1E3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "..\Tasks\FRcrsn.h"

class TInfoAppl;
class FTskAkerm;
class FAkerm : public FRcrsn  
{
public:

	long nN;		//	  - m
	long nM;		//	  - n
	long nF;		//	 
	FAkerm(int m, int n, TInfoAppl *pInf, int r);
	virtual ~FAkerm();
private:
	int x1();
	int x2();
	int x3();
	int x4();
	void y1();
	void y2();
	void y3();
	void y4();
	void y5();
	void y6();
	void y7();
	void y8();
	void y9();
	void y10();
	void y11();
	void y12();
	void y13();

protected:
	void CallAkerman(int m, int n, TInfoAppl *pInf, int r)	{
		if (pRcrsn) delete pRcrsn;
		pRcrsn = new FAkerm(m,n,pInf,r);
		pRcrsn->FCall(this); 
	}
	int  PrevAkerman()	{ 
		if (!pRcrsn) return nF;
		return ((FAkerm*)pRcrsn)->nF; 
	}
};

#endif // !defined(AFX_FAKERM_H__8776F961_B0EC_11D6_B4EC_00C0DF0F1E3A__INCLUDED_)
