// FTskAkerm.cpp: implementation of the FTskAkerm class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"
#include "FTskAkerm.h"
#include "FAkerm.h"
#include "..\Views\FViewAkerm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern int arrr[4][20000];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FTskAkerm::FTskAkerm(TInfoAppl *pInf, TNetFsa *pNt)
	:FTask(pInf, pNt)
{
	bIfMemo= false;
	bIfMemo= true;
	pAkerm = NULL;
	pViewStates=NULL;
	for (int i=0;i<5;i++) {
//		for (int j=0; j<2000000; j++) {
		for (int j=0; j<2000; j++) {
			arr[i][j]=0;
		}
	}
}

FTskAkerm::~FTskAkerm()
{
	if (pAppl) delete pAppl;
	if (pViewStates) delete pViewStates;
}

void FTskAkerm::y1()
{
	pAppl = NULL;
	pViewStates=NULL;
	int nAkerm = ((CRcrsnView*)pInfo->pOutWnd)->m_nAkerm;
	int n_mAkerm = ((CRcrsnView*)pInfo->pOutWnd)->m_n_mAkerm;
	pAppl = new FAkerm(n_mAkerm, nAkerm, pInfo, 1);

	if (((CRcrsnView*)pInfo->pOutWnd)->m_bViewStateAkerm) {
		pViewStates = new FViewAkerm(pNet, pInfo);
		pViewStates->SetPtrFsaAppl((LFsaAppl**)&pAppl);
		pNet->go_task();
	}
	
	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeAkerm(0);	
	((CRcrsnView*)pInfo->pOutWnd)->ViewValueAkerm(0);	

	void ClearAkkerman();
	ClearAkkerman();
	timeStart = LTime();
	int Akerman (TInfoAppl *pInf, int m, int n);
	int Akerman_2 (TInfoAppl *pInf, int m, int n);
	int Akerman_3 (TInfoAppl *pInf, int m, int n);
//	((FAkerm*)pAppl)->nF = Akerman(pInfo, n_mAkerm, nAkerm); 
//	((FAkerm*)pAppl)->nF = Akerman_2(pInfo, n_mAkerm, nAkerm); 
//	((FAkerm*)pAppl)->nF = Akerman_3(pInfo, n_mAkerm, nAkerm); 

	FTask::y1();

}

void FTskAkerm::y2()
{
	FTask::y2();
	((CRcrsnView*)pInfo->pOutWnd)->ViewValueAkerm(((FAkerm*)pAppl)->nF);	
	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeAkerm(nSeconds);	
	if (pAppl) delete pAppl;
	if (pViewStates) delete pViewStates;
	pAppl = NULL;
	pViewStates=NULL;
}
// 3,1 - 220 (660)
// 3,2 - 990 (3300)
// 3,3 - 4400 (14500)
// 3,4 - 18600 (61800)
