// FFact.cpp: implementation of the FFact class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FFact.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern LArc TT_Fact[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//	  
FFact::FFact(int n, TInfoAppl *pInf, int r)
	:FRcrsn(TT_Fact, pInf, r)
{
	nX=n; nK=0; nF=1;
}

FFact::~FFact() { }

LArc TT_Fact[] = {
	LArc("f1", "00", "x1",	"--"),	//
	LArc("f1", "f1", "^x1",	"y1"),	//
	LArc()
	};

int FFact::x1() { return nX==nK; }

void FFact::y1() { 
	nK++; nF *=nK; 
	((CRcrsnView*)pInfo->pOutWnd)->ViewFact(nF);	
}

//	   
int factorial_1(int n) 
{ 
	return n?(n*factorial_1(n-1)):1; 
} 

//	-  
int factorial_2(int n) 
{
	int nK=0, nF=1; 
	while (nK != n) {
		nK ++;
		nF *=nK;
	}
	return nF; 
} 
