// FFactRec.cpp: implementation of the FFactRec class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FFactRec.h"
#include "FTskFact.h"

#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern LArc TT_FactRec[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
//	   
FFactRec::FFactRec(int n, TInfoAppl *pInf, int r)
	:FRcrsn(TT_FactRec, pInf, r)
{
	if (!pInfo->pTskFact) {
		nRange=r;
	}

	nK=n; nF=1;	
}

FFactRec::~FFactRec() { }

LArc TT_FactRec[] = {
	LArc("f1", "00", "x1",	"y3"),		//
	LArc("f1", "f2", "^x1",	"y1"),		//
	LArc("f2", "00", "--",	"y2y3"),	//
	LArc()
	};

int FFactRec::x1() { return nK==0; }

void FFactRec::y1() { CallFactorial(pInfo->pTskFact->IncRange()); }

void FFactRec::y2() { 
	nF = PrevFactorial()*nK; 
	((CRcrsnView*)pInfo->pOutWnd)->ViewFact(nF);	
}

void FFactRec::y3() { 
	pInfo->pTskFact->DecRange(); 
}

//	  
int factorial(int n) 
{
	if (n == 1) return 1;
	else {
		return n*factorial(n-1);
	}
} 
