// FFactRec.h: interface for the FFactRec class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FFACTREC_H__FB585101_B036_11D6_B4EC_00C0DF0F1E3A__INCLUDED_)
#define AFX_FFACTREC_H__FB585101_B036_11D6_B4EC_00C0DF0F1E3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "..\Tasks\FRcrsn.h"

class TInfoAppl;
class FFactRec : public FRcrsn
{
public:
	int nF;		//	
	FFactRec(int n, TInfoAppl *pInf, int r);
	virtual ~FFactRec();

private:
	int nK;		//	
	int x1();
	void y1();
	void y2();
	void y3();

protected:
	void CallFactorial(int r)	{
		if (pRcrsn) delete pRcrsn;
		pRcrsn = new FFactRec(nK-1, pInfo, r);
		pRcrsn->FCall(this); 
	};
	int  PrevFactorial()	{ 
		return ((FFactRec*)pRcrsn)->nF; 
	};
};

#endif // !defined(AFX_FFACTREC_H__FB585101_B036_11D6_B4EC_00C0DF0F1E3A__INCLUDED_)
