// FTskFact.cpp: implementation of the FTskFact class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Rcrsn.h"
#include "..\RcrsnDoc.h"
#include "..\RcrsnView.h"
#include "..\TInfoAppl.h"
#include "FTskFact.h"
#include "FFact.h"
#include "FFactRec.h"
#include "..\Views\FViewFact.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FTskFact::FTskFact(TInfoAppl *pInf, TNetFsa *pNt)
	:FTask(pInf, pNt)
{
	pViewStates=NULL;

}

FTskFact::~FTskFact()
{
	if (pViewStates) delete pViewStates;
}

void FTskFact::y1()
{
	pAppl = NULL;
	pViewStates=NULL;
	int nFact = ((CRcrsnView*)pInfo->pOutWnd)->m_nFact;
//	pAppl = new FFact(nFact, pInfo, 1);
	pAppl = new FFactRec(nFact, pInfo, 1);
	if (((CRcrsnView*)pInfo->pOutWnd)->m_bViewStateFact) {
		pViewStates = new FViewFact(pNet, pInfo);
		pViewStates->SetPtrFsaAppl((LFsaAppl**)&pAppl);
		pNet->go_task();
	}
	
	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeFact(0);	
	((CRcrsnView*)pInfo->pOutWnd)->ViewFact(0);	

	timeStart = LTime();
	int factorial(int n);
	((FFactRec*)pAppl)->nF = factorial(nFact);
//	FTask::y1();

}

void FTskFact::y2()
{
	FTask::y2();
	((CRcrsnView*)pInfo->pOutWnd)->ViewFact(((FFactRec*)pAppl)->nF);	
	((CRcrsnView*)pInfo->pOutWnd)->ViewTimeFact(nSeconds);	
	if (pAppl) delete pAppl;
	if (pViewStates) delete pViewStates;
	pAppl = NULL;
	pViewStates=NULL;
}
