// RcrsnView.cpp : implementation of the CRcrsnView class
//

#include "stdafx.h"
#include "Rcrsn.h"

#include "RcrsnDoc.h"
#include "RcrsnView.h"
#include "TInfoAppl.h"
#include "Hanoy\FHanoy.h"
#include "Factorial\FFactRec.h"
#include "Akerman\FAkerm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CRcrsnApp theApp;
/////////////////////////////////////////////////////////////////////////////
// CRcrsnView

IMPLEMENT_DYNCREATE(CRcrsnView, CFormView)

BEGIN_MESSAGE_MAP(CRcrsnView, CFormView)
	//{{AFX_MSG_MAP(CRcrsnView)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BTN_st_all, OnBTNstall)
	ON_EN_KILLFOCUS(IDC_EDT_n_hanoy, OnKillfocusEDTnhanoy)
	ON_EN_KILLFOCUS(IDC_EDT_thread_hanoy, OnKillfocusEDTthreadhanoy)
	ON_EN_KILLFOCUS(IDC_EDT_n_fact, OnKillfocusEDTnfact)
	ON_EN_KILLFOCUS(IDC_EDT_thread_fact, OnKillfocusEDTthreadfact)
	ON_EN_KILLFOCUS(IDC_EDT_thread_akerm, OnKillfocusEDTthreadakerm)
	ON_EN_KILLFOCUS(IDC_EDT_m_akerm, OnKillfocusEDTmakerm)
	ON_EN_KILLFOCUS(IDC_EDT_n_akerm, OnKillfocusEDTnakerm)
	ON_BN_CLICKED(IDC_CHK_Factorial, OnCHKFactorial)
	ON_BN_CLICKED(IDC_CHK_Akerman, OnCHKAkerman)
	ON_BN_CLICKED(IDC_CHK_Hanoy, OnCHKHanoy)
	ON_BN_CLICKED(IDC_CHK_vst_akerm, OnCHKvstakerm)
	ON_BN_CLICKED(IDC_CHK_vst_hanoy, OnCHKvsthanoy)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRcrsnView construction/destruction

CRcrsnView::CRcrsnView()
	: CFormView(CRcrsnView::IDD)
{
	//{{AFX_DATA_INIT(CRcrsnView)
	m_strTimerProc1 = _T("");
	m_strTimerProc2 = _T("");
	m_strTimerProc3 = _T("");
	m_nHanoy = 0;
	m_nThreadHanoy = 0;
	m_cstrRangeHanoy = _T("");
	m_cstrViewStateHanoy = _T("");
	m_cstrHanoy1 = _T("");
	m_cstrHanoy2 = _T("");
	m_cstrHanoy3 = _T("");
	m_cstrRangeFact = _T("");
	m_cstrViewStateFact = _T("");
	m_cstrFact = _T("");
	m_nThreadFact = 0;
	m_nThreadAkerm = 0;
	m_nFact = 0;
	m_nAkerm = 0;
	m_n_mAkerm = 0;
	m_cstrAkerm = _T("");
	m_cstrRangeAkerm = _T("");
	m_cstrViewStateAkerm = _T("");
	m_bAkerman = FALSE;
	m_bFactorial = FALSE;
	m_bHanoy = FALSE;
	m_bOnlyThreadProc1 = FALSE;
	m_cstrTimeAkerm = _T("");
	m_bViewStateAkerm = FALSE;
	m_cstrTimeHanoy = _T("");
	m_bViewStateHanoy = FALSE;
	m_cstrTimeFact = _T("");
	m_bViewStateFact = FALSE;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	pInfo=NULL;

}

CRcrsnView::~CRcrsnView()
{
}

void CRcrsnView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRcrsnView)
	DDX_Control(pDX, IDC_SLD_TimerProc3, m_sldTimerProc3);
	DDX_Control(pDX, IDC_SLD_TimerProc2, m_sldTimerProc2);
	DDX_Control(pDX, IDC_SLD_TimerProc1, m_sldTimerProc1);
	DDX_Text(pDX, IDC_EDT_TimerProc1, m_strTimerProc1);
	DDX_Text(pDX, IDC_EDT_TimerProc2, m_strTimerProc2);
	DDX_Text(pDX, IDC_EDT_TimerProc3, m_strTimerProc3);
	DDX_Text(pDX, IDC_EDT_n_hanoy, m_nHanoy);
	DDX_Text(pDX, IDC_EDT_thread_hanoy, m_nThreadHanoy);
	DDX_Text(pDX, IDC_ST_rng_hanoy, m_cstrRangeHanoy);
	DDX_Text(pDX, IDC_ST_ViewStateHanoy, m_cstrViewStateHanoy);
	DDX_Text(pDX, IDC_ST_hanoy1, m_cstrHanoy1);
	DDX_Text(pDX, IDC_ST_hanoy2, m_cstrHanoy2);
	DDX_Text(pDX, IDC_ST_hanoy3, m_cstrHanoy3);
	DDX_Text(pDX, IDC_ST_rng_fact, m_cstrRangeFact);
	DDX_Text(pDX, IDC_ST_ViewStateFact, m_cstrViewStateFact);
	DDX_Text(pDX, IDC_ST_f_fact, m_cstrFact);
	DDX_Text(pDX, IDC_EDT_thread_fact, m_nThreadFact);
	DDX_Text(pDX, IDC_EDT_thread_akerm, m_nThreadAkerm);
	DDX_Text(pDX, IDC_EDT_n_fact, m_nFact);
	DDX_Text(pDX, IDC_EDT_n_akerm, m_nAkerm);
	DDX_Text(pDX, IDC_EDT_m_akerm, m_n_mAkerm);
	DDX_Text(pDX, IDC_ST_f_akerm, m_cstrAkerm);
	DDX_Text(pDX, IDC_ST_rng_akerm, m_cstrRangeAkerm);
	DDX_Text(pDX, IDC_ST_ViewStateAkerm, m_cstrViewStateAkerm);
	DDX_Check(pDX, IDC_CHK_Akerman, m_bAkerman);
	DDX_Check(pDX, IDC_CHK_Factorial, m_bFactorial);
	DDX_Check(pDX, IDC_CHK_Hanoy, m_bHanoy);
	DDX_Check(pDX, IDC_CHK_OnlyThreadProc1, m_bOnlyThreadProc1);
	DDX_Text(pDX, IDC_ST_time_akerm, m_cstrTimeAkerm);
	DDX_Check(pDX, IDC_CHK_vst_akerm, m_bViewStateAkerm);
	DDX_Text(pDX, IDC_ST_time_hanoy, m_cstrTimeHanoy);
	DDX_Check(pDX, IDC_CHK_vst_hanoy, m_bViewStateHanoy);
	DDX_Text(pDX, IDC_ST_time_fact, m_cstrTimeFact);
	DDX_Check(pDX, IDC_CHK_vst_fact, m_bViewStateFact);
	//}}AFX_DATA_MAP
}

BOOL CRcrsnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CRcrsnView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

	pInfo = (TInfoAppl*)GetDocument()->pInfoAppl;
	if (pInfo) {
		pInfo->SetViewWnd(this);	//    
		ViewForm();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRcrsnView printing

BOOL CRcrsnView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CRcrsnView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CRcrsnView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CRcrsnView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CRcrsnView diagnostics

#ifdef _DEBUG
void CRcrsnView::AssertValid() const
{
	CFormView::AssertValid();
}

void CRcrsnView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CRcrsnDoc* CRcrsnView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CRcrsnDoc)));
	return (CRcrsnDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRcrsnView message handlers

void CRcrsnView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	theApp.lTimeFSA1= m_sldTimerProc2.GetPos();
	char buffer[20];
	m_strTimerProc2= ltoa(theApp.lTimeFSA1, buffer, 10);
	pInfo->nTimeProc2 = atoi(m_strTimerProc2);

	theApp.lTimeFSA2= m_sldTimerProc3.GetPos();
	m_strTimerProc3= ltoa(theApp.lTimeFSA2, buffer, 10);
	pInfo->nTimeProc2 = atoi(m_strTimerProc3);

	theApp.lCountTime= m_sldTimerProc1.GetPos();
	m_strTimerProc1= ltoa(theApp.lCountTime, buffer, 10);
	pInfo->nTimeProc1 = atoi(m_strTimerProc1);
	
	UpdateData(FALSE);
	
	CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CRcrsnView::ViewForm()
{
	char pch[10];

	memset(pch,0,sizeof(pch));
	itoa(pInfo->nTimeProc1, pch, 10);
	m_strTimerProc1	=	CString(pch); 
	memset(pch,0,sizeof(pch));
	itoa(pInfo->nTimeProc2, pch, 10);
	m_strTimerProc2	=	CString(pch); 
	memset(pch,0,sizeof(pch));
	itoa(pInfo->nTimeProc3, pch, 10);
	m_strTimerProc3	=	CString(pch); 

	m_sldTimerProc1.SetRange(1, 90000);
	m_sldTimerProc1.SetTicFreq(10);
	m_sldTimerProc2.SetRange(1, 20000);
	m_sldTimerProc2.SetTicFreq(10);
	m_sldTimerProc3.SetRange(1, 10000);
	m_sldTimerProc3.SetTicFreq(10);

	m_sldTimerProc1.SetPos(pInfo->nTimeProc1);
	m_sldTimerProc2.SetPos(pInfo->nTimeProc2);
	m_sldTimerProc3.SetPos(pInfo->nTimeProc3);

	m_nHanoy = 5;
	m_nThreadHanoy = 1;

	m_nFact = 9;
	m_nThreadFact = 1;

	m_nAkerm = 3;
	m_n_mAkerm = 3;
	m_nThreadAkerm = 1;
	
	m_bViewStateFact = true;
	m_bViewStateAkerm = true;
	m_bViewStateHanoy = true;

	m_bAkerman	= pInfo->bIfAkerm;
	m_bFactorial= pInfo->bIfFact;
	m_bHanoy	= pInfo->bIfHanoy;

	UpdateData(FALSE);

}

void CRcrsnView::InitHanoy(int k) 
{
	CString cstrHanoy="";
	m_cstrHanoy1 ="";
	m_cstrHanoy2 ="";
	m_cstrHanoy3 ="";
	for (int n=k; n; n--) {
		char ach[1]; 
		_itoa(n,ach,10);
		cstrHanoy +=ach;
	}
	m_cstrHanoy1=cstrHanoy;
	UpdateData(FALSE);

}

void CRcrsnView::MoveHanoy(int k, int a, int b) 
{
	int nId1, nId2;

	CString *pCStr1;
	CString *pCStr2;
	if (a==1) {
		pCStr1=&m_cstrHanoy1;
		nId1=IDC_ST_hanoy1;
	}
	else if (a==2) {
		pCStr1=&m_cstrHanoy2;
		nId1=IDC_ST_hanoy2;
	}
	else if (a==3) {
		pCStr1=&m_cstrHanoy3;
		nId1=IDC_ST_hanoy3;
	}
	if (b==1) {
		pCStr2=&m_cstrHanoy1;
		nId2=IDC_ST_hanoy1;
	}
	else if (b==2) {
		pCStr2=&m_cstrHanoy2;
		nId2=IDC_ST_hanoy2;
	}
	else if (b==3) {
		pCStr2=&m_cstrHanoy3;
		nId2=IDC_ST_hanoy3;
	}
	int nLen1 = pCStr1->GetLength();
	int nLen2 = pCStr2->GetLength();
	char ch1;
	if (nLen1) {
		ch1 = (*pCStr1)[nLen1-1];
		pCStr1->Delete(nLen1-1,1);

	}
	pCStr2->Insert(nLen2+1, ch1);
	
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(nId1);
	pEdt->SetWindowText(*pCStr1);
	pEdt = (CEdit*)GetDlgItem(nId2);
	pEdt->SetWindowText(*pCStr2);

//	UpdateData(FALSE);
	
}

/*
void CRcrsnView::ViewStatesHanoy(CString strSt, int r)
{
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_ViewStateHanoy);
	pEdt->SetWindowText(strSt);


	char buffer[20];
	m_cstrRangeHanoy = itoa(r, buffer, 10);
	pEdt = (CEdit*)GetDlgItem(IDC_ST_rng_hanoy);
	pEdt->SetWindowText(m_cstrRangeHanoy);
}
*/

void CRcrsnView::ViewStatesHanoy(LFsaAppl **pFAppl)
{

	CString strSt;
	int r;
	strSt = (*pFAppl)->FGetState();
	r = ((FHanoy*)(*pFAppl))->nRange;

	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_ViewStateHanoy);
	pEdt->SetWindowText(strSt);


	char buffer[20];
	m_cstrRangeHanoy = itoa(r, buffer, 10);
	pEdt = (CEdit*)GetDlgItem(IDC_ST_rng_hanoy);
	pEdt->SetWindowText(m_cstrRangeHanoy);

}

void CRcrsnView::OnBTNstall() 
{
	// TODO: Add your control notification handler code here
	pInfo->LoadProcesses();
	
}

void CRcrsnView::OnKillfocusEDTnhanoy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::OnKillfocusEDTthreadhanoy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::ViewStatesFact(LFsaAppl **pFAppl)
{
	CString strSt;
	int r;
	strSt = (*pFAppl)->FGetState();
	r = ((FFactRec*)(*pFAppl))->nRange;

	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_ViewStateFact);
	pEdt->SetWindowText(strSt);


	char buffer[20];
	m_cstrRangeFact = itoa(r, buffer, 10);
	pEdt = (CEdit*)GetDlgItem(IDC_ST_rng_fact);
	pEdt->SetWindowText(m_cstrRangeFact);
}

void CRcrsnView::ViewFact(int n)
{
	char buffer[20];
	m_cstrFact = itoa(n, buffer, 10);
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_f_fact);
	pEdt->SetWindowText(m_cstrFact);
}

void CRcrsnView::OnKillfocusEDTnfact() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::OnKillfocusEDTthreadfact() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::ViewStatesAkerm(LFsaAppl **pFAppl)
{
	CString strSt;
	int r;
	strSt = (*pFAppl)->FGetState();
	r = ((FAkerm*)(*pFAppl))->nRange;

	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_ViewStateAkerm);
	pEdt->SetWindowText(strSt);


	char buffer[20];
	m_cstrRangeAkerm = itoa(r, buffer, 10);
	pEdt = (CEdit*)GetDlgItem(IDC_ST_rng_akerm);
	pEdt->SetWindowText(m_cstrRangeAkerm);
}

void CRcrsnView::ViewValueAkerm(long n)
{
	char buffer[40];
	m_cstrAkerm = ltoa(n, buffer, 10);
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_f_akerm);
	pEdt->SetWindowText(m_cstrAkerm);
}

void CRcrsnView::ViewTimeFact(int nSec)
{
	char buffer[20];
	m_cstrTimeFact = itoa(nSec, buffer, 10);
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_time_fact);
	pEdt->SetWindowText(m_cstrTimeFact);
}

void CRcrsnView::ViewTimeAkerm(int nSec)
{
	char buffer[20];
	m_cstrTimeAkerm = itoa(nSec, buffer, 10);
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_time_akerm);
	pEdt->SetWindowText(m_cstrTimeAkerm);
}

void CRcrsnView::ViewTimeHanoy(int nSec)
{
	char buffer[20];
	m_cstrTimeHanoy = itoa(nSec, buffer, 10);
	CEdit* pEdt;
	pEdt = (CEdit*)GetDlgItem(IDC_ST_time_hanoy);
	pEdt->SetWindowText(m_cstrTimeHanoy);
}

void CRcrsnView::OnKillfocusEDTthreadakerm() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::OnKillfocusEDTmakerm() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
}

void CRcrsnView::OnKillfocusEDTnakerm() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
}

void CRcrsnView::OnCHKFactorial() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pInfo->bIfFact=m_bFactorial;
}

void CRcrsnView::OnCHKAkerman() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pInfo->bIfAkerm=m_bAkerman;
}

void CRcrsnView::OnCHKHanoy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pInfo->bIfHanoy=m_bHanoy;
}

void CRcrsnView::OnCHKvstakerm() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CRcrsnView::OnCHKvsthanoy() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}
