// RcrsnView.h : interface of the CRcrsnView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RCRSNVIEW_H__A574932F_B5EF_11D6_A493_B3E8A3553183__INCLUDED_)
#define AFX_RCRSNVIEW_H__A574932F_B5EF_11D6_A493_B3E8A3553183__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class TInfoAppl;
class CRcrsnView : public CFormView
{
protected: // create from serialization only
	CRcrsnView();
	DECLARE_DYNCREATE(CRcrsnView)

public:
	//{{AFX_DATA(CRcrsnView)
	enum { IDD = IDD_RCRSN_FORM };
	CSliderCtrl	m_sldTimerProc3;
	CSliderCtrl	m_sldTimerProc2;
	CSliderCtrl	m_sldTimerProc1;
	CString	m_strTimerProc1;
	CString	m_strTimerProc2;
	CString	m_strTimerProc3;
	int		m_nHanoy;
	int		m_nThreadHanoy;
	CString	m_cstrRangeHanoy;
	CString	m_cstrViewStateHanoy;
	CString	m_cstrHanoy1;
	CString	m_cstrHanoy2;
	CString	m_cstrHanoy3;
	CString	m_cstrRangeFact;
	CString	m_cstrViewStateFact;
	CString	m_cstrFact;
	int		m_nThreadFact;
	int		m_nThreadAkerm;
	int		m_nFact;
	int		m_nAkerm;
	int		m_n_mAkerm;
	CString	m_cstrAkerm;
	CString	m_cstrRangeAkerm;
	CString	m_cstrViewStateAkerm;
	BOOL	m_bAkerman;
	BOOL	m_bFactorial;
	BOOL	m_bHanoy;
	BOOL	m_bOnlyThreadProc1;
	CString	m_cstrTimeAkerm;
	BOOL	m_bViewStateAkerm;
	CString	m_cstrTimeHanoy;
	BOOL	m_bViewStateHanoy;
	CString	m_cstrTimeFact;
	BOOL	m_bViewStateFact;
	//}}AFX_DATA

// Attributes
public:
	CRcrsnDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRcrsnView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void ViewTimeAkerm(int nSec);
	void ViewStatesAkerm(LFsaAppl **pFAppl);
	void ViewValueAkerm(long n);

	void ViewTimeFact(int nSec);
	void ViewStatesFact(LFsaAppl **pFAppl);
	void ViewFact(int n);

	void ViewTimeHanoy(int nSec);
	void ViewStatesHanoy(LFsaAppl **pFAppl);
	void InitHanoy(int n);
	void MoveHanoy(int k, int a, int b);

	TInfoAppl *pInfo;
	void ViewForm();
	virtual ~CRcrsnView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRcrsnView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBTNstall();
	afx_msg void OnKillfocusEDTnhanoy();
	afx_msg void OnKillfocusEDTthreadhanoy();
	afx_msg void OnKillfocusEDTnfact();
	afx_msg void OnKillfocusEDTthreadfact();
	afx_msg void OnKillfocusEDTthreadakerm();
	afx_msg void OnKillfocusEDTmakerm();
	afx_msg void OnKillfocusEDTnakerm();
	afx_msg void OnCHKFactorial();
	afx_msg void OnCHKAkerman();
	afx_msg void OnCHKHanoy();
	afx_msg void OnCHKvstakerm();
	afx_msg void OnCHKvsthanoy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in RcrsnView.cpp
inline CRcrsnDoc* CRcrsnView::GetDocument()
   { return (CRcrsnDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RCRSNVIEW_H__A574932F_B5EF_11D6_A493_B3E8A3553183__INCLUDED_)
