// FTask.cpp: implementation of the FTask class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FTask.h"
#include "FRcrsn.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern LArc TT_Task[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FTask::FTask(TInfoAppl *pInf, TNetFsa *pNt)
	:LFsaAppl(TT_Task)
{
	pAppl = NULL;
	pInfo=pInf;
	pNet = pNt;
	timeStart = LTime();
}

FTask::~FTask() { 
	if (pAppl) delete pAppl;
}

LArc TT_Task[] = {
	LArc("t1", "t2", "--",	"y1"),	//
	LArc("t2", "00", "--",	"y2"),	//
	};

void FTask::y1()
{
	pAppl->FCall(this);
	timeStart = LTime();
}

void FTask::y2()
{
	timeEnd = LTime();
	nSeconds = (timeEnd.mSecond() - timeStart.mSecond()); 
}

int FTask::IncRange()
{
	return pAppl->nRange++;
}

int FTask::DecRange()
{
	return pAppl->nRange--;
}
